/*---------------------------------------------------------------------------------------------
 *  Licensed under the MIT License.
 *
 *  @Author: fantasticsoul
 *--------------------------------------------------------------------------------------------*/
import { deepCopy } from './copy';
import { getDraftMeta } from './meta';
export function original(mayDraftProxy) {
    const meta = getDraftMeta(mayDraftProxy);
    // use ternary conditional operator instead of meta?.self
    // avoid generating redundant compiled code
    const self = meta ? meta.self : mayDraftProxy;
    return self;
}
export function current(mayDraftProxy) {
    const meta = getDraftMeta(mayDraftProxy);
    if (!meta) {
        return mayDraftProxy;
    }
    return deepCopy(meta.copy || meta.self);
}
